//************************************************************************************
//**  
//**  File name:     C:\Documents and Settings\paul bunion\Desktop\FlowCodeAVR4\Examples\TUT_01.c
//**  Generated by:  Flowcode v4.3.6.61
//**  Date:          Friday, June 04, 2010 03:48:14
//**  Licence:       Professional
//**  
//**        ***UNREGISTERED***
//**  
//**  
//**     NOT FOR COMMERCIAL USE
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_AVR

//Defines for microcontroller
#define MX_AVR
#define MX_EE
#define MX_EE_SIZE 1024
#define MX_SPI
#define MX_SPI_B
#define MX_SPI_SDI 6
#define MX_SPI_SDO 5
#define MX_SPI_SCK 7
#define MX_UART
#define MX_UART_ID
#define MX_UART_UCSRC
#define MX_UART_D
#define MX_UART_TX 1
#define MX_UART_RX 0
#define MX_MI2C
#define MX_I2C_C
#define MX_I2C_SDA 1
#define MX_I2C_SCL 0
#define MX_PWM
#define MX_PWM_PORT PORTD
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 DDRD
#define MX_PWM_1 5
#define MX_PWM_TRIS2 DDRD
#define MX_PWM_2 4
#define MX_PWMTYPE 1

//Functions
#define F_CPU 20000000UL
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\eeprom.h>
#include <avr\wdt.h>
#include <MX_util\delay.h>
#include <MX_util\bit_cmds.h>

//Configuration data
#pragma DATA 0x0, 0xdf
#pragma DATA 0x1, 0xff
#pragma DATA 0x2, 0xff

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode AVR V4\FCD\internals.h"

//Macro function declarations
void FCM_INTERRUPT_TMR0();
void FCM_INTERRUPT_RB0INT();
void FCM_INTERRUPT_PORTB();


//Variable declarations


//Defines:

/**** Macro Substitutions ****
PORTA = LED Port Register
DDRA = LED Data Direction Register
3 = Number of LEDs
1 = LED Pin 0
2 = LED Pin 1
4 = LED Pin 2
8 = LED Pin 3
0 = LED Pin 4
0 = LED Pin 5
0 = LED Pin 6
0 = LED Pin 7
******************************/




//LEDs(1): //Macro function declarations

static void FCD_LEDs1_LEDOn(char WhichLED);
static void FCD_LEDs1_LEDOff(char WhichLED);



//LEDs(1): //Macro implementations


static void FCD_LEDs1_LEDOn(char WhichLED)
{
		char LEDMask;

		if (WhichLED > 3)
		{
			LEDMask = 0;
		}
		else
		{
			switch (WhichLED)
			{
				case 0:
					LEDMask = 1;
					break;
				case 1:
					LEDMask = 2;
					break;
				case 2:
					LEDMask = 4;
					break;
				case 3:
					LEDMask = 8;
					break;
				case 4:
					LEDMask = 0;
					break;
				case 5:
					LEDMask = 0;
					break;
				case 6:
					LEDMask = 0;
					break;
				case 7:
					LEDMask = 0;
					break;
			}
		}
		DDRA = DDRA | LEDMask;
		PORTA = PORTA | LEDMask;
}

static void FCD_LEDs1_LEDOff(char WhichLED)
{
		char LEDMask;

		if (WhichLED > 3)
		{
			LEDMask = 0;
		}
		else
		{
			switch (WhichLED)
			{
				case 0:
					LEDMask = 1;
					break;
				case 1:
					LEDMask = 2;
					break;
				case 2:
					LEDMask = 4;
					break;
				case 3:
					LEDMask = 8;
					break;
				case 4:
					LEDMask = 0;
					break;
				case 5:
					LEDMask = 0;
					break;
				case 6:
					LEDMask = 0;
					break;
				case 7:
					LEDMask = 0;
					break;
			}
		}
		DDRA = DDRA | LEDMask;
		PORTA = PORTA & ~LEDMask;
}

//Macro implementations

void FCM_INTERRUPT_TMR0()
{
	
}

void FCM_INTERRUPT_RB0INT()
{
	
}

void FCM_INTERRUPT_PORTB()
{
	
}

int main()
{
	//Lighting an LED (A0)
	
	//Initialisation
	MCUSR=0x00;
	wdt_disable();


	//Interrupt initialisation code
	
	//Comment:
	//Using IO icons


	//Clear Port A
	//Output: 0 -> PORT A
	DDRA = 0xFF;
	PORTA = 0;


	//Light an LED (A0)
	//Output: 1 -> PORT A
	DDRA = 0xFF;
	PORTA = 1;


	//Delay
	//Delay: 1 s
	delay_s(1);


	//Comment:
	//Using component macros


	//Call Component Macro
	//Call Component Macro: LEDs(1)::LEDOff(0)
	FCD_LEDs1_LEDOff(0);


	//Delay
	//Delay: 1 s
	delay_s(1);


	//Call Component Macro
	//Call Component Macro: LEDs(1)::LEDOn(0)
	FCD_LEDs1_LEDOn(0);


	mainendloop: goto mainendloop;
}



